Subject: Re: [netconf] some comments on netconf-adaptive-subscription

From: Qin Wu <[email-masked]>
Date: Fri, 25 Jun 2021 14:16:17 +0000

Thanks Michael for valuable comments, see reply inline below.
-----邮件原件-----
发件人: Michael Richardson [mailto:[email-masked]] 
发送时间: 2021年6月25日 3:15
收件人: Qin Wu <[email-masked]>; [email-masked]
抄送: [email-masked]
主题: some comments on netconf-adaptive-subscription

>I read:
>        Title           : Adaptive Subscription to YANG Notification
>	Filename        : draft-wang-netconf-adaptive-subscription-05.txt

>today.  I understand the need for some kind of way to switch between some kind of periodic capture of value vs a edge-triggered/on-change process.

>I'm a bit surprised that the example-wifi-mac module had to be created in the appendix to provide an example.  Surely we should already have likely modules that are really being used and need this 

>kind of thing.
>So one recommendation is that the document focus on already published YANG models that could benefit from this kind of subscription.

[Qin]: That's a good suggestion, WiFi provides a good use case for this adaptive subscription mechanism. we did try some existing published YANG models, but it seems YANG models size is too big.
That's why we create simplified Wifi mac example Module. If you can provide a link to CHIP/MATTER WIFI statistics module, we are happy to quote that existing module.

>(Perhaps the wifi-mac module is something that also needs to exist, and does not.  I will note that CHIP/MATTER has some kind of WIFI statistics module, but it's not presently written up in YANG)

>I had to back to RFC8641, which I don't know well at all, to be sure I understood the xpath criteria.  I guess I don't understand how RFC8641 and this document can be used for non-XML serialized 

>YANG interactions.
[Qin]: RFC8641 is built on top of RFC8639, RFC8639 Subscribe Notification module allow you specify encoding, take RESTCONF as an example, you can specify any encoding you like.

>If bandwidth is at a premium, wouldn't you want to use draft-ietf-core-comi-11 (YANG in CBOR) rather than XML?
[Qin]: The intention is to optimize the existing YANG push mechanism for NETCONF/RESTCONF and other management protocols. And the network device can support multiple capture periodic intervals, the mechanism we introduce is to allow the network device switch to different capture periodic interval automatically without asking the NMS for permission each time. I hope this clarifies.
>At which point, the obvious interaction with RFC7641 would need to be explained?

>It seems that the netconf (RESTCONF) and CORECONF groups should spend some more time together.

[Qin]: I am also hoping RESTCONF and CORECONF can work together, but they seems to look into different use cases (constrained device management vs unconstrained device management) .
I am not sure we should generalized RESTCONF and CORECONF into a single protocol.
My understanding they have a different basis, for CORECONF, the basis is COMI, should it be extended to support pub sub?, there is one relevant draft, i.e.,
Draft-birkholdz-yang-core-telemetry, 
RFC7641 have different basis, which is coap, it seems introduce similar pub sub mechanism, but I confused this work with draft-ietf-core-coap-pubsub. So what about other IoT protocol such as MQTT? It also support pub sub mechanism.
I think we should not mix coap with comi, otherwise, we will see a lot of mess and confusion. Am I right?

--
]               Never tell me the odds!                 | ipv6 mesh networks [
]   Michael Richardson, Sandelman Software Works        |    IoT architect   [
]     [email-masked]  http://www.sandelman.ca/        |   ruby on rails    [

--
Michael Richardson <[email-masked]>   . o O ( IPv6 IøT consulting )
           Sandelman Software Works Inc, Ottawa and Worldwide

---

From: Michael Richardson <[email-masked]>
Date: Fri, 25 Jun 2021 12:09:31 -0400

Qin Wu <[email-masked]> wrote:
    > [Qin]: That's a good suggestion, WiFi provides a good use case for this
    > adaptive subscription mechanism. we did try some existing published
    > YANG models, but it seems YANG models size is too big.  That's why we
    > create simplified Wifi mac example Module. If you can provide a link to
    > CHIP/MATTER WIFI statistics module, we are happy to quote that existing
    > module.

The CHIP/MATTER document not public yet, but Huawei is a member and can get the document.
But, it's not a YANG module.  The fact that they have a set of wifi
statistics in their base definition argues that there ought to be an
equivalent YANG model though.

    > [Qin]: The intention is to optimize the existing YANG push mechanism
    > for NETCONF/RESTCONF and other management protocols. And the network
    > device can support multiple capture periodic intervals, the mechanism
    > we introduce is to allow the network device switch to different capture
    > periodic interval automatically without asking the NMS for permission
    > each time. I hope this clarifies.

yes, I understood that from the document.

    > [Qin]: I am also hoping RESTCONF and CORECONF can work together, but
    > they seems to look into different use cases (constrained device
    > management vs unconstrained device management) .  I am not sure we
    > should generalized RESTCONF and CORECONF into a single protocol.

That's not what I'm suggesting.
I'm asking, if bandwidth is an issue, why not use a smaller encoding.
And, why not integrate with CoAP Observe?

---

From: Michael Richardson <[email-masked]>
Date: Fri, 25 Jun 2021 12:51:00 -0400

> That's not what I'm suggesting.  I'm asking, if bandwidth is an issue,
    > why not use a smaller encoding.  And, why not integrate with CoAP
    > Observe?

draft-birkholz-yang-core-telemetry-01 [now expired] for instance tries to do
a lot of the matching.  I think that the adaptive rate subscription that
you've created would work very well within that model.

I guess yang-core-telemetry-01 needs to update itself as
ietf-netconf-subscribed-notifications is published as RFC 8639 right.

I still don't know how XPath would work with COMI, but really I'm just
sitting around the edges of the YANG over the wire space.